#include <device.h>
#include <stdio.h>
#include <stdlib.h>
#include "font.h"
#include "lcd_ls022.h"

void SendCom (unsigned int com)
{
DC_Write(0);
LCD_DATA_Write(com);
WR_Write(0);
WR_Write(1);
DC_Write(1);
 }
/////////////////////////////////////////////////////////////////////
void SendDat (unsigned int dat)
{
LCD_DATA_Write(dat);
WR_Write(0);
WR_Write(1);
 }
/////////////////////////////////////////////////////////////////////
void LCDinit (char mode)
{ 
DC_Write(1);
RES_Write(0);
CyDelay (1);	//15 Us
RES_Write(1);
CyDelay (5);	 
SendCom(0x11);       // Sleep Out 
SendCom(0x29);       // Display On
CyDelay (1);	 
SendCom(0x36);       	//   Memory Access Control 
(mode) ? SendDat(0b11000000) : SendDat(0b10100000) ; 	//SendDat(0b10100000);	//   (0b00000111)-24 битный режим  bit7-Bottom to Top; bit6-Right to Left;  bit5-Page/Column  .....
SendCom(0x3A);       // Interface Pixel Format 
SendDat(0b00000111); // 12 bit/pixel=011;   16 bit/pixel=101;    18 bit/pixel=110;   24 bit/pixel=111;    
  }
/////////////////////////////////////////////////////////////////////
void LCDclear(char mode)
{ unsigned long int i;
     SendCom(0x2A+mode);				// 	КомандаориетациипоХкоординате
     SendDat(0);  SendDat(0);  	// 	x1   ДанныеначалаХкоординат (0)
     SendDat(1);  SendDat(65);  //	x2   анные конца   Х координат (240)
     SendCom(0x2b-mode);    			//	Команда ориентации по Y координате
     SendDat(0);  SendDat(0);  	// y1 Данные начала Y координат (0)
     SendDat(0);  SendDat(240);	// y2 Данные конца   Y координат (320)
     SendCom(0x2C);				//Команда записи в память дисплея
  for (i=0;i<7680;i++) {
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1); LCD_DATA_Write(0); WR_Write(0); WR_Write(1);
  } 
}
//**********************************************************************************************************

void SetWindow(unsigned int Xs, unsigned int Ys, unsigned int Xe,unsigned int Ye)
{
SendCom(0x2A);
SendDat (hi(Xs));
SendDat (lo(Xs));
SendDat (hi(Xe));
SendDat (lo(Xe));
SendCom(0x2B);
SendDat (hi(Ys));
SendDat (lo(Ys));
SendDat (hi(Ye));
SendDat (lo(Ye));
}
/*-----------------------------------------------------------------------------------------------------*/
/////////////////////////////////////////////////////////////////////
void LCDchar0(unsigned int x, unsigned int y, char c, char color_r, char color_g, char color_b, char bgcolor_r, char bgcolor_g, char bgcolor_b )
{
char h,ch,p,mask;

SetWindow(x, y, x+7, y+14);

     SendCom(0x2C);

 for (h=0; h<14; h++) // для каждой колонки символа
  {   
        ch=font[c][0+h];		// начало образа символа
        mask=0x80;				// начнем с левого пикселя
        for (p=0; p<8; p++)  	// write the pixels
          {
          if (ch&mask)			// если это символ рисуем его пиксель
            {SendDat(color_r);SendDat(color_g);SendDat(color_b);}
           else					// если это фон рисуем цвет фона
            {SendDat(bgcolor_r);SendDat(bgcolor_g);SendDat(bgcolor_b);}
          mask=mask/2;			//  следующий пиксель
          }
  }
}
/////////////////////////////////////////////////////////////////
void LCDchar(unsigned int x, unsigned int y, char c, char color_r, char color_g, char color_b, char bgcolor_r, char bgcolor_g, char bgcolor_b, unsigned int Scale )
{
char h,ch,p,mask,i,j;

	j=2;
	SetWindow(x, y, x+(8*Scale)-1, y+(14*Scale));

     SendCom(0x2C);

 for (h=0; h<14; h++) // every column of the character
  {   
        ch=font[c][0+h];
 
  for (j=0; j<Scale; j++)	
   {	mask=0x80;
        for (p=0; p<8; p++)  // write the pixels
          {
          if (ch&mask)
            {for (i=0; i<Scale; i++)	{ SendDat(color_r);SendDat(color_g);SendDat(color_b);}			}
		  else
			{for (i=0; i<Scale; i++)	{ SendDat(bgcolor_r);SendDat(bgcolor_g);SendDat(bgcolor_b);}	}
			mask=mask/2;
		   }
   }	

  }
}
////////////////////////////////////////////////////////////////////////////////////

void LCDpixel(unsigned int x,unsigned int y, char color_r, char color_g, char color_b)
{    SetWindow(x, y, x, y);
     SendCom(0x2C);
     SendDat(color_r);SendDat(color_g);SendDat(color_b);
}
/////////////////////////////////////////////////////////////////////////////////////////
/***********************************************************************************************************************
description:            High level functions to work with graphic displays
author:                 VDLab
***********************************************************************************************************************/
/*----------------------------------------------------------------------------------------------------------------------
function:               Line
description:            draw line by Bresenham algorithm 
input:                  Xstart,Ystart - line start coordinates
                        Xend,Yend - line end coordinates
output:                 none
----------------------------------------------------------------------------------------------------------------------*/
void Line(int Xstart, int Ystart, int Xend, int Yend, char color_r, char color_g, char color_b)
{
unsigned int nTmp;
unsigned int nAlt=0;
int x,y;                                    // where is the current pixel.
int dx;   	                                // dx is the delta for x
int dy;   	                                // dy is the delta for y
int StepVal=0;                              // variable for figuring out when to increment the other axis.
if (Xstart>Xend && Ystart>Yend)
    {
	nTmp=Xend;
	Xend=Xstart;
	Xstart=nTmp;
	nTmp=Yend;
	Yend=Ystart;
	Ystart=nTmp;
	
	dx=Xend-Xstart;                         // dx is the delta for x
	dy=Yend-Ystart;                         // dy is the delta for y
    }
else
    {
	dx=Xend-Xstart;                         // dx is the delta for x
	dy=Yend-Ystart;                         // dy is the delta for y
	if (dy<0)
        {	
		dy=-dy;
		nTmp=Yend;
		Yend=Ystart;
		Ystart=nTmp;			
		nAlt=1;
        }
	else
		if (dx<0)
			{	
			dx=-dx;
			nTmp=Xend;
			Xend=Xstart;
			Xstart=nTmp;
			nAlt=1;
			}
	}
	if (nAlt)
	    {
        if(dx>=dy)                          // The slope is less than 45 degres
            {
			y=Yend;
			for(x=Xstart; x<=Xend; x++)
                {
				LCDpixel(x,y,color_r,color_g,color_b);
				StepVal+=dy;
				if(StepVal>=dx)             // Increment y if enough x steps have been taken.
                    {
					y--;
					StepVal-=dx;            // Reset StepVal, but not to 0.  This gives even slopes.
                    }
                }
            }
		else                                // The slope is greater than 45 degrees, just like above, but with y instead of x.
            {
			x=Xend;
			for(y=Ystart; y<=Yend; y++)
                {
				LCDpixel(x,y,color_r,color_g,color_b);
				StepVal+=dx;
				if(StepVal>=dy)
                    {
					x--;
					StepVal-=dy;
                    }
                }
            }
		return;
        }
	if(dx>=dy)                              // The slope is less than 45 degres
        {
		y=Ystart;
		for(x=Xstart; x<=Xend; x++)
            {
			LCDpixel(x,y,color_r,color_g,color_b); 
			StepVal+=dy;
			if(StepVal>=dx)                 // Increment y if enough x steps have been taken.
                {
				y++;
				StepVal-=dx;                // Reset StepVal, but not to 0.  This gives even slopes.
                }
            }
        }
	else                                    // The slope is greater than 45 degrees, just like above, but with y instead of x.
        {
		x=Xstart;
		for(y=Ystart; y<=Yend; y++)
            {
			LCDpixel(x,y,color_r,color_g,color_b);
			StepVal+=dx;
			if(StepVal>=dy)
                {
				x++;
				StepVal-=dy;
                }
            }
        }
	return;
}
/*----------------------------------------------------------------------------------------------------------------------
function:               Circle
description:            draw circle by Bresenham algorithm 
input:                  x,y - center coordinates
                        r - radius of circle
                        color - 16 bit value of color in RGB-565 format
output:                 none
----------------------------------------------------------------------------------------------------------------------*/

void Circle(int x, int y, int r, char color_r, char color_g, char color_b)
{
int x1,y1,yk = 0;
int sigma,delta,f;

x1 = 0;
y1 = r;
delta = 2*(1-r);
do
    {
    LCDpixel(x+x1,y+y1,color_r,color_g,color_b);
    LCDpixel(x-x1,y+y1,color_r,color_g,color_b);
    LCDpixel(x+x1,y-y1,color_r,color_g,color_b);
    LCDpixel(x-x1,y-y1,color_r,color_g,color_b);
    f = 0;
    if (y1 < yk) break;
    if (delta < 0)
        {
        sigma = 2*(delta+y1)-1;
        if (sigma <= 0)
            {
            x1++;
            delta += 2*x1+1;
            f = 1;
            }
        }
    else
        if (delta > 0)
            {
            sigma = 2*(delta-x1)-1;
            if (sigma > 0)
                {
                y1--;
                delta += 1-2*y1;
                f = 1;
                }
            } 
        if (!f)
            {
            x1++;
            y1--;
            delta += 2*(x1-y1-1);
            }
        }
    while(1);
}

/*----------------------------------------------------------------------------------------------------------------------
function:               PutStr
description:            put string to display
input:                  x,y - position of text start
                        *str - pointer to string to output
output:                 none
----------------------------------------------------------------------------------------------------------------------*/
void PutStr(unsigned int x, unsigned int y, const char *str, char color_r, char color_g, char color_b, char bgcolor_r, char bgcolor_g, char bgcolor_b, unsigned int Scale)
{
	char cmprr;
	
while ((cmprr = *str++))
    {
	LCDchar(x,y,cmprr,color_r,color_g,color_b,bgcolor_r,bgcolor_g,bgcolor_b, Scale );
	x+=8*Scale;
	if (x>Disp_with-9) return; 
	}
}
/*----------------------------------------------------------------------------------------------------------------------
function:               Rectangle
description:            draw rectangle
input:                  x,y - upper left corner coordinates
                        width - width of rectangle
                        height -height of rectangle
                        Filled - if =1 - rectangle is filled
output:                 none
----------------------------------------------------------------------------------------------------------------------*/
void Rectangle(unsigned int X, unsigned int Y, unsigned int Width, unsigned int Height,unsigned char Filled,char color_r, char color_g, char color_b)
{
	unsigned long tmp;
	
SetWindow(X,Y,X+(Width-1),Y+(Height-1));
if (Filled)
	{
	tmp = (unsigned long)Height*Width;
	SendCom(0x2C);
	do  {
    	SendDat(color_r);
		SendDat(color_g);
		SendDat(color_b);
    	}while(tmp--);
	}
else
	{
	Line(X,Y,X+(Width-1),Y,color_r,color_g,color_b);
	Line(X,Y+1,X,Y+(Height-1),color_r,color_g,color_b);
	Line(X+1,Y+(Height-1),X+(Width-1),Y+(Height-1),color_r,color_g,color_b);
	Line(X+(Width-1),Y+1,X+(Width-1),Y+(Height-1),color_r,color_g,color_b);
	}
}
/*----------------------------------------------------------------------------------------------------------------------
function:               Window
description:            draw windows95 like window 
input:                  x,y - upper left corner coordinates
                        width - width of window
                        height -height of window
                        header - pointer to window header string 
output:                 none
----------------------------------------------------------------------------------------------------------------------*/
void Window(unsigned int X, unsigned int Y, unsigned int Width, unsigned int Height,char type, const char *header)
{
Rectangle(X+1,Y+1,Width-2,Height-2,0,window);
Rectangle(X+2,Y+2,Width-4,14,1,blue);
PutStr(X+4,Y+2,header,white,blue,1);
Line(X+1,Y+16,X+(Width-2),Y+16,window);
//--------client region----------------------------------------
switch (type)
    {
    case 0:
        {  Rectangle(X+2,Y+17,(Width-4),Height-19,1,window);   break; }
    case 1:
        {
        Rectangle(X+2,Y+17,(Width-4),Height-19,0,black);
        Rectangle(X+3,Y+18,(Width-6),(Height-21),1,white);
        break;
        }
    case 2:
        { Rectangle(X+2,Y+17,(Width-4),Height-19,1,black); break; }
    default:
        {
         Rectangle(X+2,Y+17,(Width-4),Height-19,0,black);
         Rectangle(X+3,Y+18,(Width-6),(Height-21),1,lgrey);
        break;
        }
    }
}
///////////////////////////////////////////////////////////////


void draw_bitmap24over(unsigned int X, unsigned int Y, unsigned int Width, unsigned int Height,char *filename)
{
	unsigned long tmp;
	
SetWindow(X,Y,X+(Width-1),Y+(Height-1));

	tmp = (unsigned long)Height*Width;
	unsigned long i;
	SendCom(0x2C);
	for( i = 0; i<tmp; i++) {
    	SendDat(filename[(3*i)+2]);
		SendDat(filename[(3*i)+1]);
		SendDat(filename[(3*i)+0]);
	};
}
//-----------------------------------------------------------------------------------------------------

void draw_bitmap24(unsigned int X, unsigned int Y, unsigned int Width, unsigned int Height,char *filename)
{
	unsigned long tmp;
	
SetWindow(X,Y,X+(Width-1),Y+(Height-1));

	tmp = (unsigned long)Height*Width;

	SendCom(0x2C);
do  {
    	SendDat(filename[(3*tmp)+2]);
		SendDat(filename[(3*tmp)+1]);
		SendDat(filename[(3*tmp)+0]);
    	}while(tmp--);;
}
//----------------------------------------------------------------------------------------------------

